package casper;

import java.util.LinkedList;
import java.util.Iterator;
import java.util.StringTokenizer;
import phi.psiData;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Free_variables {

    //Consts
    static final int LAST = -1;

    casperData localCsprData;
    LinkedList freeVarsList;
    boolean bFreeVarsLoaded = false;

    public Free_variables(casperData csprData) {

        String szFreeVarsSection, szFirstLine;
        boolean bErrorFound=false;

        freeVarsList = new LinkedList();
        localCsprData = csprData;



        szFreeVarsSection = casperClass.getSection(csprData, "#Free", "variables");

        if ( szFreeVarsSection.matches("") )
           bErrorFound = true;

        while ( !szFreeVarsSection.matches("") && !bErrorFound) {
            szFirstLine = casperClass.getFirstLine(szFreeVarsSection);
            if ( !saveFreeVarsLine(szFirstLine, LAST) ) {
                bErrorFound = true;
                System.err.println("Debug(Protocol_description): Line was not loaded");
            }

            szFreeVarsSection = szFreeVarsSection.substring(szFirstLine.length());
        }

        if ( !bErrorFound )
            bFreeVarsLoaded = true;
    }

    public boolean isLoaded(){
        return(bFreeVarsLoaded);
    }

    //return the content of this section
    public String getContent(){

       Iterator iter;
       String szResult = "";
       FreeVarsLine tempFreeVarsLine;

       if ( bFreeVarsLoaded ) {
           for (iter = freeVarsList.iterator(); iter.hasNext(); ) {
               tempFreeVarsLine = (FreeVarsLine) iter.next();
               szResult = szResult.concat(tempFreeVarsLine.szLineContent);
           }
       } else {
           System.err.println("Debug(Protcol_description): getMessegesNumbers even though protocol description was loaded properly");
       }

       return(szResult);

    }

    //add all the necessarity definitions of a new message
    public void addMessage(){

       Iterator iter;
       psiData tempPsiData;

       if ( !localCsprData.szSenderType.matches("") )
           addVarDefinition(localCsprData.szSenderType, localCsprData.szSender);

       if ( !localCsprData.szReceiverType.matches("") )
           addVarDefinition(localCsprData.szReceiverType, localCsprData.szReceiver);

       for (iter = localCsprData.getPsiDataSet().iterator(); iter.hasNext(); ){
           tempPsiData = (psiData) iter.next();
           if ( tempPsiData.getPsiDataIdentifer().matches("Encrypting") ||
                tempPsiData.getPsiDataIdentifer().matches("EncryptedKey")) {
               if (tempPsiData.isPsiDataSymetricKey()) {
                   addVarDefinition("SessionKeys", tempPsiData.getPsiDataValue());
                   addInverseKeysDefinition(tempPsiData.getPsiDataValue());
               }
           }
           else if ( tempPsiData.getPsiDataIdentifer().matches("Body")  ||
                     tempPsiData.getPsiDataIdentifer().matches("AbstrctedBody") )
              addVarDefinition("Bodies", tempPsiData.getPsiDataValue());
       }

   }

    //add variable definition
    private void addVarDefinition(String szType, String szVar){

        FreeVarsLine tempFreeVarsLine;

        tempFreeVarsLine = getVarLine(szType);

        if ( tempFreeVarsLine == null ) {//This type does not exists
            if ( !saveFreeVarsLine(szVar + " : " + szType + "\n", getLastVarLocation() + 1) ) {
                System.err.println("Debug(Protocol_description): Line was not loaded2");
            }
        } else { //This type exists
            if ( !casperClass.DoesStrContainToken(tempFreeVarsLine.szVars.replace(',', ' '), szVar) ) { //var is not defined
                tempFreeVarsLine.szVars = tempFreeVarsLine.szVars.concat(", " + szVar);
                tempFreeVarsLine.szLineContent = tempFreeVarsLine.szVars + " : " + szType + "\n";
            }
        }

    }

    //add InverseKey definition
    private void addInverseKeysDefinition(String szKey) {

        int nLocation=0;
        FreeVarsLine tempFreeVarsLine;

        tempFreeVarsLine = getInverseKeysLine();

        if ( tempFreeVarsLine == null ){ //This type does not exists
            nLocation = getLastVarLocation();
            saveFreeVarsLine("\n", nLocation + 1);
            if ( !saveFreeVarsLine("InverseKeys = (" + szKey + ", " + szKey + ")\n", nLocation + 2) ) {
                System.err.println("Debug(Protocol_description): Line was not loaded3");
            }
        } else { //This type exists
            if ( !casperClass.DoesStrContainToken(tempFreeVarsLine.szKeys.replace(',', ' '), szKey) ) { //var is not defined
                tempFreeVarsLine.szKeys = tempFreeVarsLine.szKeys.concat(", " + szKey);
                tempFreeVarsLine.szLineContent = tempFreeVarsLine.szLineContent.trim().concat(", ("+szKey+", "+szKey+")\n");
            }
        }

    }


    /*************************************
    //FreeVar list functions
    ***************************************/
    //return an array of all messages numbers
    public String[] getParticipants() {

       Iterator iter;
       int nParticipantsNum = 1, nIndex=0;
       StringTokenizer st;

       String[] numbersArray=null;

       if ( bFreeVarsLoaded ) {
          for (int i=0; i < localCsprData.Types.length; i++)
             if ( getVarLine(localCsprData.Types[i]) != null)
                nParticipantsNum = nParticipantsNum + getVarLine(localCsprData.Types[i]).getVarsNumber();

          numbersArray = new String[nParticipantsNum];

          for (int i=0; i < localCsprData.Types.length; i++)
              if ( getVarLine(localCsprData.Types[i]) != null ) {
                  st = new StringTokenizer(getVarLine(localCsprData.Types[i]).szVars.replaceAll(","," "));
                  while ( st.hasMoreTokens() ){
                      numbersArray[nIndex] = st.nextToken();
                      nIndex ++;
                  }

              }

          numbersArray[nIndex] = "Else";
       } else {
           System.err.println("Debug(Free_variables): getParticipants was called even though protocol description was loaded properly");
       }

       return(numbersArray);
    }

    //Get a specific line of var definition
    private FreeVarsLine getVarLine(String szType) {

        Iterator iter;

        FreeVarsLine tempFreeVarsLine;

        if ( bFreeVarsLoaded ) {
            for (iter = freeVarsList.iterator(); iter.hasNext(); ) {
                tempFreeVarsLine = (FreeVarsLine) iter.next();
                if ( tempFreeVarsLine.isVarDefinition && tempFreeVarsLine.szType.matches(szType) )
                    return(tempFreeVarsLine);
            }
        } else {
            System.err.println("Debug(Free_variables): getVarLine was called even though protocol description was loaded properly");
        }

        return(null);
    }

    //Get the inverseKeys line definition
    private FreeVarsLine getInverseKeysLine() {

        Iterator iter;

        FreeVarsLine tempFreeVarsLine;

        if ( bFreeVarsLoaded ) {
            for (iter = freeVarsList.iterator(); iter.hasNext(); ) {
                tempFreeVarsLine = (FreeVarsLine) iter.next();
                if ( tempFreeVarsLine.isInverseKeys )
                    return(tempFreeVarsLine);
            }
        } else {
            System.err.println("Debug(Free_variables): getInverseKeysLine was called even though protocol description was loaded properly");
        }

        return(null);
    }


    //save a line in the list
    private boolean saveFreeVarsLine(String szLine, int nLocation){

        FreeVarsLine newFreeVarsLine = new FreeVarsLine();

        newFreeVarsLine.setLine(szLine);

        if ( !newFreeVarsLine.bLineLoaded )
            return(false);

        if ( nLocation == LAST )
            freeVarsList.addLast(newFreeVarsLine);
        else
            freeVarsList.add(nLocation, newFreeVarsLine);


        return(true);
    }

    //returns the location of the last var difinition
    private int getLastVarLocation() {

       Iterator iter;
       int nLocation=0, nResult=2;


       FreeVarsLine tempFreeVarsLine;


       for (iter = freeVarsList.iterator(); iter.hasNext(); ){
           tempFreeVarsLine = (FreeVarsLine) iter.next();
           if ( tempFreeVarsLine.isVarDefinition )
               nResult = nLocation;

           nLocation++;

       }

       return(nResult);
    }




}
