package casper;

import javax.swing.JOptionPane;
import java.util.LinkedList;
import java.util.Iterator;
import java.util.StringTokenizer;
import phi.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Processes {

    //Consts
    static final int LAST = -1;
    static final int SENDER = 0;
    static final int RECEIVER = 1;

    casperData localCsprData;
    LinkedList processesList;
    boolean bProcessesLoaded = false;


    public Processes(casperData csprData) {

       String szProcessesSection, szFirstLine;
       boolean bErrorFound=false;

       processesList = new LinkedList();
       localCsprData = csprData;

       szProcessesSection = casperClass.getSection(csprData, "#Processes", null);

       if ( szProcessesSection.matches("") )
           bErrorFound = true;

       while ( !szProcessesSection.matches("") && !bErrorFound) {
            szFirstLine = casperClass.getFirstLine(szProcessesSection);
            if ( !saveProcessesLine(szFirstLine, LAST) ) {
                bErrorFound = true;
                System.err.println("Debug(Protocol_description): Line was not loaded");
            }

            szProcessesSection = szProcessesSection.substring(szFirstLine.length());
        }

        if ( !bErrorFound )
            bProcessesLoaded = true;
    }

    public boolean isLoaded(){
        return(bProcessesLoaded);
    }

    public String getContent() {

       Iterator iter;
       String szResult = "";
       ProcessesLine tempProcessesLine;

       if ( bProcessesLoaded ) {
           for (iter = processesList.iterator(); iter.hasNext(); ) {
               tempProcessesLine = (ProcessesLine) iter.next();
               szResult = szResult.concat(tempProcessesLine.szLineContent);
           }
       } else {
           System.err.println("Debug(Protcol_description): getMessegesNumbers even though protocol description was loaded properly");
       }

       return(szResult);

    }

    //add the necessary knowledge to all process
    //for the new message
    public void addMessage(ProDesLine[] messages){

        LinkedList knowledge = new LinkedList();

        ProcessesLine tempProcessesLine;


        //Start with adding the necessary knowledge to the sender
        getKnowledgeFromDef(knowledge, localCsprData.szSender, localCsprData.szSenderType);
        getKnowledgeFromMessages(knowledge, messages, localCsprData.szSender);

        addKnowledge(knowledge, localCsprData.szSender, SENDER);

        if ( !(localCsprData.szSender.matches(localCsprData.Initator) &&
               localCsprData.szReceiver.matches(localCsprData.Responder)) ) {

            tempProcessesLine = getProcessLine(localCsprData.szSender);
            addDefinition(knowledge, tempProcessesLine, localCsprData.szReceiver);
        }

        //Add the knowledge to the receiver
        knowledge.clear();

        getKnowledgeFromDef(knowledge, localCsprData.szReceiver, localCsprData.szReceiverType);
        getKnowledgeFromMessages(knowledge, messages, localCsprData.szReceiver);

        addKnowledge(knowledge, localCsprData.szReceiver, RECEIVER);

    }

    //returns the knowledge defined in script for a given user (identity)
    public void getKnowledgeFromDef(LinkedList knowledge, String szIdentity, String szType){

        ProcessesLine tempProcessesLine;
        StringTokenizer st;
        String szKnowledge;

        tempProcessesLine = getProcessLine(szIdentity);

        if ( tempProcessesLine == null ) { //There is no process definition for this user
            if ( szType.matches("") )
                System.err.println("Processes: getKnowledge: type is empty and user does not exists");

            if ( processNameExists(szType) ) {
                JOptionPane.showMessageDialog(null,
                             szType +" exists, two processes cannot be defined with the same name",
                                              "Error",JOptionPane.ERROR_MESSAGE);
                bProcessesLoaded = true;
            }

            if ( !saveProcessesLine(szType + "(" + szIdentity + ") knows PK, SK(" + szIdentity + ")\n", lastProcessLoc() + 1) )
                System.err.println("Debug:getKnowledge - line could not be loaded");

            knowledge.add(szIdentity);

        } else { //Process definition exists

            szKnowledge = tempProcessesLine.szKnowledge;
            szKnowledge = szKnowledge.replaceAll(" ,", " ");
            szKnowledge = szKnowledge.replaceAll(", ", " ");
            st = new StringTokenizer(szKnowledge, ",");
            while (st.hasMoreTokens())
                knowledge.add(st.nextToken());
        }
    }

    //returns the knowledge a user (identity) accuried from messages he receives
    public void getKnowledgeFromMessages(LinkedList knowledge,
                                         ProDesLine[] messages,
                                         String szIdentity){
        String szMessage;

        for (int i=0; i < messages.length; i++)
            if ( messages[i].szSecondIdentifier.matches(szIdentity) ) {
                knowledge.add(messages[i].szFirstIdentifier);
                szMessage = messages[i].szMessage.trim().replaceAll(" ,", ",").replaceAll(", ", ",");
                getKnowledgeFromMessageSeq(knowledge, szMessage);
            }
    }

    //returns the knowledge a user (identity) accuried from messages he receives
    private void getKnowledgeFromMessageSeq(LinkedList knowledge, String szMessage) {

        StringTokenizer st = new StringTokenizer(szMessage, ",");
        String szFact;
        int nRBracket, nCBracket;

        if ( st.countTokens() > 1 ) { //It is probably a sequence
            while ( st.hasMoreTokens() ) {
                szFact = st.nextToken();
                nRBracket = casperClass.numOfClosesNeeded(szFact, '(', ')');
                nCBracket = casperClass.numOfClosesNeeded(szFact, '{', '}'); ;

                while (st.hasMoreTokens() && (nRBracket > 0 || nCBracket > 0)) {
                    szFact = szFact.concat("," + st.nextToken());
                    nRBracket = casperClass.numOfClosesNeeded(szFact, '(', ')');
                    nCBracket = casperClass.numOfClosesNeeded(szFact, '{', '}'); ;
                }

                if (nRBracket == 0 && nCBracket == 0)
                    getKnowledgeFromMessageFact(knowledge, szFact);
                else {
                    JOptionPane.showMessageDialog(null,
                                                  szMessage + "\n Invalid bracketing",
                                                  "Error",
                                                  JOptionPane.ERROR_MESSAGE);

                    bProcessesLoaded = false;
                }
            }
        } else
            getKnowledgeFromMessageFact(knowledge, szMessage);
    }

    private void getKnowledgeFromMessageFact(LinkedList knowledge, String szMessage) {

        if ( casperClass.isEncryption(szMessage) > -1) { //It is and encryption
            getKnowledgeFromMessageSeq(knowledge, szMessage.substring(1, casperClass.isEncryption(szMessage)));
        } else if ( casperClass.isHash(szMessage) ) { //It is hash or reference
            //Do nothing
        } else if (szMessage.indexOf('.') > -1 ||
                   szMessage.indexOf('#') > -1 ||
                   szMessage.indexOf('(') > -1 ||
                   szMessage.indexOf(')') > -1 ||
                   szMessage.indexOf('{') > -1 ||
                   szMessage.indexOf('}') > -1 ) {

            JOptionPane.showMessageDialog(null,
                                             "invalid atom - " + szMessage, "Error",
                                             JOptionPane.ERROR_MESSAGE);

            bProcessesLoaded = false;
        } else
            knowledge.add(szMessage);
    }

    //Add the necessariy knowledge to the sender
    private void addKnowledge(LinkedList knowledge, String szIdentity, int nToWho) {

        ProcessesLine tempProcessesLine;

        Iterator iter;
        psiData tempPsiData;

        if ( !bProcessesLoaded )
            return;

        tempProcessesLine = getProcessLine(szIdentity);

        if ( tempProcessesLine == null) { //definition for this identity does not exists
            System.err.println("Process: addKnowledgeToSender: definition does not exists");
        } else { //definition exists
            for (iter = localCsprData.getPsiDataSet().iterator(); iter.hasNext(); ){
                tempPsiData = (psiData) iter.next();
                if ( (tempPsiData.getPsiDataIdentifer().matches("Encrypting") ||
                     tempPsiData.getPsiDataIdentifer().matches("EncryptedKey")) ){

                    if ( tempPsiData.isPsiDataSymetricKey() ) {
                        if (nToWho == RECEIVER && !isEncryptedKey(tempPsiData.getPsiDataValue()))
                            addDefinition(knowledge, tempProcessesLine, tempPsiData.getPsiDataValue());

                        if (nToWho == SENDER)
                            addDefinition(knowledge, tempProcessesLine, tempPsiData.getPsiDataValue());
                    }
                }

                //Key used for encryption which was hashed. For exmaple
                //an encryption hashed inside body element
                else if ( tempPsiData.getPsiDataIdentifer().matches("HashEncrypting") ){

                   if ( tempPsiData.isPsiDataSymetricKey() && nToWho == SENDER)
                       addDefinition(knowledge, tempProcessesLine, tempPsiData.getPsiDataValue());

               }

                else if (nToWho == SENDER && tempPsiData.getPsiDataIdentifer().matches("Hash") ){

                    addDefinition(knowledge, tempProcessesLine, (String)tempPsiData.getPsiDataValue());
                }
                else if (nToWho == SENDER && phiClass.isAtom(tempPsiData.getPsiDataIdentifer()) )
                    addDefinition(knowledge, tempProcessesLine, tempPsiData.getPsiDataValue());
            }

        }

    }

    private void addDefinition(LinkedList knowledge, ProcessesLine line, String szValue){

        Iterator iter;
        String szToken;
        boolean bInKnowledge = false;

        for (iter = knowledge.iterator(); iter.hasNext(); ) {
            szToken = (String) iter.next();
            if ( szToken.trim().matches(szValue.trim()) )
               bInKnowledge = true;
        }

        if ( !bInKnowledge && !casperClass.DoesStrContainToken(line.szKnowledge.replace(',', ' '), szValue) ) {
            line.szKnowledge = line.szKnowledge.concat(", " + szValue);
            line.szLineContent = line.szProcessName + "(" + line.szKnowledge +
                                 ")" + line.szRest;
        }
    }

    //Return true if the key is encrypted in the message
    private boolean isEncryptedKey(String szKey) {

        Iterator iter;
        psiData tempPsiData;

        for (iter = localCsprData.getPsiDataSet().iterator(); iter.hasNext(); ){
            tempPsiData = (psiData) iter.next();
            if ( tempPsiData.getPsiDataValue().matches(szKey) &&
                 tempPsiData.getPsiDataIdentifer().matches("EncryptedKey") )
                return(true);
        }

        return(false);
    }


    /*************************************
    //Processes list functions
    ***************************************/
   //save a line in the list
    private boolean saveProcessesLine(String szLine, int nLocation){

        ProcessesLine newProcessesLine = new ProcessesLine();

        newProcessesLine.setLine(szLine);

        if ( !newProcessesLine.bLineLoaded )
            return(false);

        if ( nLocation == LAST )
            processesList.addLast(newProcessesLine);
        else
            processesList.add(nLocation, newProcessesLine);


        return(true);
    }

    //Get a specific line of process definition
    private ProcessesLine getProcessLine(String szIdentity) {

        Iterator iter;

        ProcessesLine tempProcessesLine;

        if ( bProcessesLoaded ) {
            for (iter = processesList.iterator(); iter.hasNext(); ) {
                tempProcessesLine = (ProcessesLine) iter.next();
                if ( tempProcessesLine.isProcessDef && tempProcessesLine.szProcessIdentity.matches(szIdentity) )
                    return(tempProcessesLine);
            }
        } else {
            System.err.println("Debug(Processes): getProcessLine was called even though protocol description is not loaded properly");
        }

        return(null);
    }

    //returns true if process name exists and false otherwise
    private boolean processNameExists(String szName){

        Iterator iter;

        ProcessesLine tempProcessesLine;

        if ( bProcessesLoaded ) {
            for (iter = processesList.iterator(); iter.hasNext(); ) {
                tempProcessesLine = (ProcessesLine) iter.next();
                if ( tempProcessesLine.isProcessDef && tempProcessesLine.szProcessName.matches(szName) )
                    return(true);
            }
        } else {
            System.err.println("Debug(Processes): getVarLine was called even though protocol description was loaded properly");
        }

        return(false);

    }

    //returns the location of the last process definition line
    private int lastProcessLoc(){

        Iterator iter;
        int nLocation=0, nResult=1;

        ProcessesLine tempProcessesLine;

        if ( bProcessesLoaded ) {
            for (iter = processesList.iterator(); iter.hasNext(); ) {
                tempProcessesLine = (ProcessesLine) iter.next();
                if ( tempProcessesLine.isProcessDef )
                    nResult = nLocation;

                nLocation++;
            }
        } else {
            System.err.println("Debug(Processes): getVarLine was called even though protocol description was loaded properly");
        }

        return(nResult);

    }




}
