package casper;

import javax.swing.JOptionPane;
import java.util.List;
import java.util.LinkedList;
import java.util.Iterator;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Protocol_description {

    casperData localCsprData;
    LinkedList proDesList;
    boolean bProtDesLoaded=false;


    public Protocol_description(casperData csprData) {

        String szProtocolDescriptionSection, szFirstLine;
        boolean bErrorFound =false;

        proDesList = new LinkedList();
        localCsprData = csprData;

        szProtocolDescriptionSection = casperClass.getSection(csprData, "#Protocol", "description");

        if ( szProtocolDescriptionSection.matches("") )
            bErrorFound = true;

        while ( !szProtocolDescriptionSection.matches("") ) {
            szFirstLine = casperClass.getFirstLine(szProtocolDescriptionSection);
            if ( !saveProDesLine(szFirstLine) ) {
                bErrorFound = true;
                System.err.println(
                        "Debug(Protocol_description): Line was not loaded");
            }

            szProtocolDescriptionSection = szProtocolDescriptionSection.substring(szFirstLine.length());
        }

        if ( !bErrorFound )
            bProtDesLoaded = true;
    }

    public boolean isLoaded(){
        return(bProtDesLoaded);
    }

    //return the content of this section
    public String getContent(){

       Iterator iter;
       String szResult = "";
       ProDesLine tempProDesLine;

       if ( bProtDesLoaded ) {
           for (iter = proDesList.iterator(); iter.hasNext(); ) {
               tempProDesLine = (ProDesLine) iter.next();
               szResult = szResult.concat(tempProDesLine.szLineContent);
           }
       } else {
           System.err.println("Debug(Protcol_description): getMessegesNumbers even though protocol description was loaded properly");
       }

       return(szResult);

    }

    public void addMessage(String szNewMessage) {

        int nLocation;
        ProDesLine tempProDesLine = new ProDesLine();

        tempProDesLine.bIsMessage = true;
        tempProDesLine.szLineNo = localCsprData.szMsgNum;
        tempProDesLine.szFirstIdentifier = localCsprData.szSender;
        tempProDesLine.szSecondIdentifier = localCsprData.szReceiver;
        tempProDesLine.szMessage = szNewMessage;
        tempProDesLine.szLineContent =
            localCsprData.szMsgNum + ".  " +
            localCsprData.szSender + " -> " +
            localCsprData.szReceiver + " : " +
            szNewMessage + "\n";
        tempProDesLine.bLineLoaded = true;

        nLocation = getLocation(localCsprData.szAfterMsg);

        if ( nLocation > -1)
            saveProDesLineInLocation(tempProDesLine, nLocation + 1);
        else
            System.err.println("Debug(Protcol_description): Line " + localCsprData.szMsgNum + " could not be found");


    }


    /*************************************
    //proDesSet list functions
     ***************************************/
    //return an array of all messages numbers
    public String[] getMessegesNumbers() {

       Iterator iter;
       int nLinesNumber, nIndex=0;
       ProDesLine tempProDesLine;

       String[] numbersArray=null;

       if ( bProtDesLoaded ) {
           nLinesNumber = getLength();
           if ( nLinesNumber > 0 ) {
               numbersArray = new String[nLinesNumber];
               for (iter = proDesList.iterator(); iter.hasNext(); ) {
                   tempProDesLine = (ProDesLine) iter.next();
                   if (tempProDesLine.bIsMessage) {
                       numbersArray[nIndex] = tempProDesLine.szLineNo;
                       nIndex++;
                   }
               }
           }
       } else {
           System.err.println("Debug(Protcol_description): getMessegesNumbers even though protocol description was loaded properly");
       }

       return(numbersArray);
    }

    //return an array of all messages
    public ProDesLine[] getMesseges() {

       Iterator iter;
       int nLinesNumber, nIndex=0;
       ProDesLine tempProDesLine;

       ProDesLine[] messagesArray=null;

       if ( bProtDesLoaded ) {
           nLinesNumber = getLength();
           if ( nLinesNumber > 0 ) {
               messagesArray = new ProDesLine[nLinesNumber];
               for (iter = proDesList.iterator(); iter.hasNext(); ) {
                   tempProDesLine = (ProDesLine) iter.next();
                   if (tempProDesLine.bIsMessage) {
                       messagesArray[nIndex] = tempProDesLine;
                       nIndex++;
                   }
               }
           }
       } else {
           System.err.println("Debug(Protcol_description): getMessegesNumbers even though protocol description was loaded properly");
       }

       return(messagesArray);
    }


    private boolean saveProDesLine(String szLine){

        ProDesLine newProDesLine = new ProDesLine();

        newProDesLine.setLine(szLine);

        if ( !newProDesLine.bLineLoaded )
            return(false);

        proDesList.addLast(newProDesLine);

        return(true);
    }


    //Saves the line in the specified Location
    private void saveProDesLineInLocation(ProDesLine newProDesLine, int nLocation){

        proDesList.add(nLocation, newProDesLine);
    }

    //returns the location of the given message
    private int getLocation(String szMessageNumber) {

       Iterator iter;
       int nLocation=0;

       ProDesLine tempProDesLine;


       for (iter = proDesList.iterator(); iter.hasNext(); ){
           tempProDesLine = (ProDesLine) iter.next();
           if ( tempProDesLine.bIsMessage )
               if (tempProDesLine.szLineNo.matches(szMessageNumber))
                   return (nLocation);

           nLocation++;

       }

       return(-1);
    }


    //returns the number of message lines in the script
    private int getLength() {

       Iterator iter;
       int nLinesNumber=0;

       ProDesLine tempProDesLine;


       for (iter = proDesList.iterator(); iter.hasNext(); ){
           tempProDesLine = (ProDesLine) iter.next();
           if ( tempProDesLine.bIsMessage )
               nLinesNumber++;
       }

       return(nLinesNumber);
    }

}
