package casper;

import javax.swing.JOptionPane;
import java.util.StringTokenizer;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class casperClass {

    public casperClass() {
    }

    public static String InitScript(casperData csprData){

        String szAgentDef, szPublicKeyDef;

        if ( csprData.szInitatorType.equals(csprData.szResponderType) ) {
            szAgentDef = csprData.Initator + ", " + csprData.Responder + " : " +  csprData.szInitatorType;
            szPublicKeyDef = "PK : " + csprData.szInitatorType + " -> PublicKey\n" +
                             "SK : " + csprData.szInitatorType + " -> SecretKey";
        } else {
            szAgentDef = csprData.Initator + " : " + csprData.szInitatorType + "\n" +
                         csprData.Responder + " : " + csprData.szResponderType;

            szPublicKeyDef = "PK : " + csprData.szInitatorType + " -> PublicKey\n" +
                             "SK : " + csprData.szInitatorType + " -> SecretKey\n" +
                             "PK : " + csprData.szResponderType + " -> PublicKey\n" +
                             "SK : " + csprData.szResponderType + " -> SecretKey";
        }
        return("#Free variables\n\n" +
               szAgentDef + "\n" +
               szPublicKeyDef + "\n" +
               "h, R : HashFunction\n" +
               "\n" +
               "InverseKeys = (PK, SK)" +
               "\n\n\n" +
               "#Processes\n\n" +
               "INITIATOR(" + csprData.Initator + ") knows PK, SK(" + csprData.Initator + ")\n" +
               "RESPONDER(" + csprData.Responder + ") knows PK, SK(" + csprData.Responder + ")" +
               "\n\n\n" +
               "#Protocol description\n\n" +
               "0.     -> " + csprData.Initator + " : "  + csprData.Responder +
               "\n\n\n" +
               "#Specification\n\n" +
               "\n" +
               "#Actual variables\n\n" +
               "\n" +
               "#Inline functions\n\n" +
               "symbolic PK, SK\n" +
               "\n" +
               "#System\n\n" +
               "\n" +
               "#Intruder information"
        );
    }

    public static String updateScript(casperData csprData, String szMessage){

        Free_variables freeVars = new Free_variables(csprData);
        Processes processes = new Processes(csprData);
        Protocol_description proDes = new Protocol_description(csprData);
        Specification specification = new Specification(csprData);
        Actual_variables actualVars = new Actual_variables(csprData);
        Inline_functions inlineFunctions = new Inline_functions(csprData);
        casperSystem system = new casperSystem(csprData);
        Intruder_information intruderInfo = new Intruder_information(csprData);


        freeVars.addMessage();
        processes.addMessage(proDes.getMesseges());
        proDes.addMessage(szMessage);


        if ( !freeVars.isLoaded() ||
             !processes.isLoaded() ||
             !proDes.isLoaded() ||
             !specification.isLoaded() ||
             !actualVars.isLoaded() ||
             !inlineFunctions.isLoaded() ||
             !system.isLoaded() ||
             !intruderInfo.isLoaded() )
          return("");



        return(freeVars.getContent() +
               processes.getContent() +
               proDes.getContent() +
               specification.getContent() +
               actualVars.getContent() +
               inlineFunctions.getContent() +
               system.getContent() +
               intruderInfo.getContent());
    }

    public static String getSection(casperData csprData, String szNameFirst, String szNameSecond){

        int nStartPosition, nEndPosition;
        String szFullName, szSecondWord;

        if ( szNameSecond == null )
            szFullName = szNameFirst;
        else
            szFullName = szNameFirst + " " + szNameSecond;

        nStartPosition = csprData.szScript.indexOf(szNameFirst);

        //Check that the following word is szNameSecond
        while ( szNameSecond != null && nStartPosition > -1) {
           szSecondWord = getSecondWord(csprData.szScript.substring(nStartPosition));

           if ( szSecondWord != null && szSecondWord.equals(szNameSecond) )
               break;
           else
               nStartPosition = csprData.szScript.indexOf(szNameFirst, nStartPosition +1);
        }

        if ( nStartPosition > -1) {
           nEndPosition = csprData.szScript.indexOf('#', nStartPosition + 1);

           if ( nEndPosition < nStartPosition )
               nEndPosition = csprData.szScript.length();

           return(csprData.szScript.substring(nStartPosition, nEndPosition));

       } else {
           JOptionPane.showMessageDialog(null,
                          szFullName + " section could be found in script", "Error",
                          JOptionPane.ERROR_MESSAGE);
           return("");
       }


    }

    //Get the second word of a string
    public static String getSecondWord(String szSection) {

       StringTokenizer st;

       st = new StringTokenizer(szSection);

       if ( st.countTokens() > 1 ) {
           st.nextToken(); //First Word
           return(st.nextToken()); //return the second word
       } else
           return(null);
   }

   //Retruns true if token is in string
   public static boolean DoesStrContainToken(String szStr, String szToken){

      StringTokenizer st;

      st = new StringTokenizer(szStr);

      while (st.hasMoreTokens()) {
          if ( st.nextToken().matches(szToken) )
              return(true);
      }

      return(false);

   }

   public static String getFirstLine(String szSection){

       int nEndPos, nStratPos=0;
       String szResult = "";

       nEndPos = szSection.indexOf('\n');

       while ( nEndPos > 0 && szSection.charAt(nEndPos-1) == '\\' ) {
           szResult = szResult.concat(szSection.substring(nStratPos, nEndPos-1) + " ");
           nStratPos = nEndPos + 1;
           nEndPos = szSection.indexOf('\n', nEndPos + 1);
       }

       szResult = szResult.concat(szSection.substring(nStratPos, nEndPos + 1));

       return(szResult);
   }

   //Check if a given token has an encryption structure and if it does
   //reutrns the first close braket position '}' if it is proper encryption
   //and -1 if it is not
   public static int isEncryption(String szToken) {

       int indexOfFirstClose=-1, nBracketsToClose=1;

       szToken = szToken.trim();

       for (int i=1; i < szToken.length(); i++) {

           if ( szToken.charAt(i) == '{' )
               nBracketsToClose++;

           if ( szToken.charAt(i) == '}' )
               nBracketsToClose--;

           if (nBracketsToClose == 0) {
               indexOfFirstClose = i;
               break;
           }
       }


       if (szToken.charAt(0) == '{' &&
           indexOfFirstClose > 1 &&
           szToken.lastIndexOf('{') ==
           indexOfFirstClose + 1 &&
           szToken.lastIndexOf('}') ==
           szToken.length() - 1) {

         return(indexOfFirstClose);
       }

       return(indexOfFirstClose);

   }

   //Check if a given token has an hash/reference structure and if it does
   //reutrns true otherwise returns false
   public static boolean isHash(String szToken) {

       szToken = szToken.trim();

       int indexOfFirstOpen = szToken.indexOf('(');

       if (indexOfFirstOpen > 0 &&
           szToken.lastIndexOf(')') == szToken.length() - 1 ){

         return(true);
       }

       return(false);

   }

   //return how many more opens in a string then closes.
   //in other words how many closes need to balance between opens
   //and closes
   public static int numOfClosesNeeded(String szStr, int nOpen, int nClose){

       int nDifference=0;

       for (int i=0; i < szStr.length(); i++) {
           if (szStr.charAt(i) == nOpen )
               nDifference++;

           if (szStr.charAt(i) == nClose )
               nDifference--;

       }

       return(nDifference);
   }


}
