package phi;

import javax.swing.JOptionPane;
import java.util.StringTokenizer;
import casper.casperClass;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Body {
    public Body() {
    }

    /***********************************************
     * phi of Body with one arguement
     ************************************************/
    public static String eval(phiData phData, org.w3c.dom.Node evalNode) {

      String szResult="";
      org.w3c.dom.Node indexNode;
      org.w3c.dom.NodeList list;
      int nSubChildNum=0, nPosition=0;

      list = evalNode.getChildNodes();

      for (int i=0; i < list.getLength(); i++) {
          indexNode = list.item(i);
          if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
              nSubChildNum++;
              nPosition = i;
          }
      }


      //Check if the the whole body is encrypted or there might be applicative parts
      if ( nSubChildNum == 1 && list.item(nPosition).getLocalName().equals("EncryptedData") )
          szResult = szResult.concat(getEncryptedBodyParts(phData, evalNode,null,false));
      else {
          szResult = szResult.concat(getNonEncryptedBody(phData, evalNode) + ", ");
          szResult = szResult.concat(getEncryptedBodyParts(phData, evalNode,null,false));
      }

      return(phiClass.elementStrip(szResult));
    }

    /***********************************************
     * phi of Body with two arguements
     ************************************************/
    public static String eval(phiData phData, org.w3c.dom.Node evalNode, String szArg) {

      String szResult="";
      org.w3c.dom.Node indexNode;
      org.w3c.dom.NodeList list;
      int nSubChildNum=0, nPosition=0;

      list = evalNode.getChildNodes();

      for (int i=0; i < list.getLength(); i++) {
          indexNode = list.item(i);
          if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
              nSubChildNum++;
              nPosition = i;
          }
      }

      //Check if the the whole body is encrypted or there might be applicative parts
      if ( nSubChildNum == 1 && list.item(nPosition).getLocalName().equals("EncryptedData") )
          szResult = szResult.concat(getEncryptedBodyParts(phData, evalNode, szArg, true));
      else {
          szResult = szResult.concat(getNonEncryptedBody(phData, evalNode) + ", ");
          szResult = szResult.concat(getEncryptedBodyParts(phData, evalNode, szArg, true));
      }

      return(phiClass.elementStrip(szResult));
    }


    //Get the abstraction of all the encryptedData parts of the Body element
    private static String getEncryptedBodyParts(phiData phData,
                                                org.w3c.dom.Node rootNode,
                                                String szArg,
                                                boolean bArgumentSupplied){

        org.w3c.dom.Node indexNode;
        org.w3c.dom.NodeList list;
        String szResult="", szEncryptedResult, szTemp;

        list = rootNode.getChildNodes();

        // Loop through the list.
        for (int i=0; i < list.getLength(); i++) {
            indexNode = list.item(i);
            if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
                if (indexNode.getLocalName().equals("EncryptedData") ) {
                    if ( bArgumentSupplied ) {
                        szEncryptedResult = phiClass.evaluateNode(phData, indexNode, szArg);

                        saveAtomFromEncryptedDataSeq(phData, szEncryptedResult, "Body");

                        szResult = szResult.concat(szEncryptedResult + ", ");
                    } else {
                        szEncryptedResult = phiClass.evaluateNode(phData,indexNode);

                        saveAtomFromEncryptedDataSeq(phData, szEncryptedResult, "Body");

                        szResult = szResult.concat(szEncryptedResult + ", ");
                    }
                } else {
                    szResult = szResult.concat(getEncryptedBodyParts(phData,
                                                                     indexNode,
                                                                     szArg,
                                                                     bArgumentSupplied));
                }
            }
        }

        return(szResult);
    }

    //Get the abstraction of the non-encrypted part of the Body
    private static String getNonEncryptedBody(phiData phData, org.w3c.dom.Node bodyNode) {

        String[] options = {"Yes", "No"};
        psiData psiNonEcryptedExists, psiBodyAbstraction;

        psiNonEcryptedExists = phiClass.retPsiData(phData,
                              bodyNode,
                              "DoesNonEncryptedExist",
                              "It appears that the Body element contain non-encrypted elements, do you want to abstract them? (yes/no)",
                              true,
                              options);


        if (psiNonEcryptedExists.getPsiDataValue().equalsIgnoreCase("Yes")) {
            psiBodyAbstraction = phiClass.retPsiData(phData,
                                                     bodyNode,
                                                     "AbstrctedBody",
                                                     "Please indicate how to abstract non-encrypted part of the Body element",
                                                     true,
                                                     null);

            return(psiBodyAbstraction.getPsiDataValue());
        } else
            return("");

    }

    //When body has an encryptedData child.
    //We need to know later all the atom that are encrypted there
    private static void saveAtomFromEncryptedDataSeq(phiData phData,
                                           String szEncryptedResult,
                                           String szAtomType){

        StringTokenizer st;
        String szFact;
        int nRBracket, nCBracket;

        szEncryptedResult = szEncryptedResult.replaceAll(" ,", ",");
        szEncryptedResult = szEncryptedResult.replaceAll(", ", ",");
        st = new StringTokenizer(szEncryptedResult, ",");


        if ( st.countTokens() > 1 ) { //It is probably a sequence
            while ( st.hasMoreTokens() ) {
                szFact = st.nextToken();
                nRBracket = casperClass.numOfClosesNeeded(szFact, '(', ')');
                nCBracket = casperClass.numOfClosesNeeded(szFact, '{', '}'); ;

                while (st.hasMoreTokens() && (nRBracket > 0 || nCBracket > 0)) {
                    szFact = szFact.concat("," + st.nextToken());
                    nRBracket = casperClass.numOfClosesNeeded(szFact, '(', ')');
                    nCBracket = casperClass.numOfClosesNeeded(szFact, '{', '}'); ;
                }

                if (nRBracket == 0 && nCBracket == 0)
                    saveAtomFromEncryptedDataFact(phData, szFact, szAtomType);

                else {
                    JOptionPane.showMessageDialog(null,
                                                  szEncryptedResult + "\n Invalid bracketing",
                                                  "Error",
                                                  JOptionPane.ERROR_MESSAGE);

                    phData.phiAborted = true;
                }
            }
        } else
            saveAtomFromEncryptedDataFact(phData, szEncryptedResult, szAtomType);

    }

    private static void saveAtomFromEncryptedDataFact(phiData phData,
                                           String szEncryptedResult,
                                           String szAtomType){

        if ( casperClass.isEncryption(szEncryptedResult) > -1) { //It is and encryption
            saveAtomFromEncryptedDataSeq(phData, szEncryptedResult.substring(1, casperClass.isEncryption(szEncryptedResult)), szAtomType);
            saveKeyFromBody(phData, szEncryptedResult.substring(casperClass.isEncryption(szEncryptedResult) + 2, szEncryptedResult.length() - 1));
        } else if ( casperClass.isHash(szEncryptedResult) ) { //It is hash or reference
            int nOpenBracket = szEncryptedResult.indexOf('(');
            int nCloseBracket = szEncryptedResult.lastIndexOf(')');

            saveAtomFromEncryptedDataSeq(phData, szEncryptedResult.substring(nOpenBracket + 1, nCloseBracket), "Hash");
        } else if (szEncryptedResult.indexOf('.') > -1 ||
                   szEncryptedResult.indexOf('#') > -1 ||
                   szEncryptedResult.indexOf('(') > -1 ||
                   szEncryptedResult.indexOf(')') > -1 ||
                   szEncryptedResult.indexOf('{') > -1 ||
                   szEncryptedResult.indexOf('}') > -1 ) {

            JOptionPane.showMessageDialog(null,
                                             "invalid atom - " + szEncryptedResult, "Error",
                                             JOptionPane.ERROR_MESSAGE);

            phData.phiAborted = true;
        } else
            phiClass.saveAbstractedPsiData(phData,
                                           null,
                                           szEncryptedResult,
                                           szAtomType,
                                           false);


    }

    private static void saveKeyFromBody(phiData phData, String szKey){

       boolean bSymmetric;
       szKey = szKey.trim();

       if ( (szKey.startsWith("PK(") || szKey.startsWith("SK(")) &&
            szKey.charAt(szKey.length() - 1) == ')' ){

           bSymmetric = false;
           szKey = szKey.substring(3, szKey.length() -1);
       } else
           bSymmetric = true;

       if (szKey.indexOf('.') > -1 ||
           szKey.indexOf('#') > -1 ||
           szKey.indexOf('(') > -1 ||
           szKey.indexOf(')') > -1 ||
           szKey.indexOf('{') > -1 ||
           szKey.indexOf('}') > -1 ) {

            JOptionPane.showMessageDialog(null,
                                             "invalid key in body - " + szKey, "Error",
                                             JOptionPane.ERROR_MESSAGE);

            phData.phiAborted = true;
        } else
            phiClass.saveAbstractedPsiData(phData,
                                           null,
                                           szKey,
                                           "HashEncrypting",
                                           bSymmetric);

    }
}
