package phi;

import javax.swing.JOptionPane;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

/*
SIGNATURE
 suelements

      - SignedInfo
      - SignatureValue
      - KeyInfo -> minOccur = 0
      - Object -> minOccur = 0

 attributes (all optional)
      - Id
 */
/*
 hmac structure according to - www.ietf.org/rfc/rfc2104.txt

   h(k, h(k, text))
*/

public class Signature {
    public Signature() {
    }

    /***********************************************
     * phi of Signature with one arguement
     ************************************************/
    public static String eval(phiData phData, org.w3c.dom.Node evalNode) {
        org.w3c.dom.Node indexNode,SignedInfoNode=null,KeyInfoNode=null, SignatureValueNode=null;
        org.w3c.dom.NodeList list;
        String szRefSeq, szKey="", szKeyFromSig="", szResult="", szAlgorithm;

        list = evalNode.getChildNodes();

        // Loop through the list.
        for (int i=0; i < list.getLength(); i++) {
            indexNode = list.item(i);
            if (indexNode.getNodeType() == indexNode.ELEMENT_NODE) {
                if (indexNode.getLocalName().equals("SignedInfo")) {
                    SignedInfoNode = indexNode;
                } else if (indexNode.getLocalName().equals("KeyInfo")) {
                    KeyInfoNode = indexNode;
                } else if (indexNode.getLocalName().equals("SignatureValue")) {
                    SignatureValueNode = indexNode;
                }
            }
        }

        //Get the algorithm used for signing the data
        szAlgorithm = evalSignatureMethod(phData, evalNode, SignedInfoNode);
        if (szAlgorithm.equals(""))
            return("");

        //Get the reference seq from the signedInfo
        szRefSeq = phiClass.evaluateNode(phData, SignedInfoNode);

        //if we are in abstracted mode check  the validity of the contest of
        //SignatureValue and consistency with SignedInfo information
        //return: key is used in the abstraction for checking consistency later
        if ( phData.bAbstracted ) {
            szKeyFromSig = checkSignatureValue(phData, SignatureValueNode, szAlgorithm, szRefSeq);
            if ( szKeyFromSig.equals("") )
                return("");
        }


        if (KeyInfoNode != null){

            szKey = phiClass.evaluateNode(phData, KeyInfoNode, "SIG");

            if ( szKey.matches("") )
                return("");
            else
                phiClass.saveAbstractedPsiData(phData, evalNode, szKey, "Encrypting", phData.phiIsSymmetric(szKey));


            //Check if the abstracted values in the SOAP message are consistent
            if (phData.bAbstracted) {
                if (!szKeyFromSig.equals(szKey)) {
                    //inconsistency was discovered
                    JOptionPane.showMessageDialog(null,
                            "Signature: Inconsistency between SignatureValue and KeyInfo",
                                                  "Abort", JOptionPane.ERROR_MESSAGE);
                    phData.phiAborted = true;
                    return ("");
                }
            }

            szResult = phiClass.evaluateNode(phData, KeyInfoNode) + ",";

            if ( szResult.trim().equals(",") )
                szResult = "";

        } else if (!phData.bAbstracted) {
           //KeyInfo does not appear ask the user for the key.
           szKey = checkKeyInfo(phData, evalNode, szAlgorithm);

           if ( szKey.equals("") )
               return("");

        } else {
            szKey = szKeyFromSig;
            if ( szKey.startsWith("PK(") || szKey.startsWith("SK(") )
                phiClass.saveAbstractedPsiData(phData, evalNode, szKey, "Encrypting", false);
            else
                phiClass.saveAbstractedPsiData(phData, evalNode, szKey, "Encrypting", true);
        }

        //Consistency check -
        //if hmac is used to sign, then SK can be used
        if ( szAlgorithm.equalsIgnoreCase("hmac") && szKey.startsWith("SK(") ) {
            //inconsistency was discovered
            JOptionPane.showMessageDialog(null,
                                          "Signature: Secret key cannot be used with hmac algorithm",
                                          "Abort", JOptionPane.ERROR_MESSAGE);
            phData.phiAborted = true;
            return ("");
        }
        //construct the result
        if (szAlgorithm.equalsIgnoreCase("Signature"))
            szResult = szResult.concat("{" + szRefSeq + "}{" + szKey + "}");
        else
            szResult = szResult.concat("h(" + szKey + ", h(" + szKey + ", " + szRefSeq + ")), " + szRefSeq);

        return(szResult);
    }

    /***********************************************
    * phi of Signature with two arguements
    ************************************************/
   public static String eval(phiData phData, org.w3c.dom.Node evalNode, String szArg) {
       return("Signature with two argument is not supported yet");
   }


    //Check the vliadity of the SignatureValue field.
    //Returns the signing Key if valid
    private static String checkSignatureValue(phiData phData,
                                              org.w3c.dom.Node SignatureValueNode,
                                              String szAlgorithm,
                                              String szRefSeq){

        String szSigValue, szHmacKey = "";
        int nNesting, indexOfFirstClose=-1, nSecondHash=-1;

        szSigValue = SignatureValueNode.getFirstChild().getNodeValue().trim();

        //Finding the location of First Close '}' bracket
        //in the case of public key encryption
        if ( szSigValue.charAt(0) == '{') {
            nNesting = 1;
            for (int i = 1; i < szSigValue.length() && nNesting > 0; i++) {

                if (szSigValue.charAt(i) == '{')
                    nNesting++;

                if (szSigValue.charAt(i) == '}')
                    nNesting--;

                if ( nNesting == 0)
                    indexOfFirstClose = i;
            }
        }

        //find the second h( opening in the case of
        //hmac signing
        //h(key, h(key, text))
        if ( szSigValue.startsWith("h(") && szSigValue.indexOf(',') > 2 ) {
            szHmacKey = szSigValue.substring(szSigValue.indexOf("h(") + 2, szSigValue.indexOf(',')).trim();
            nSecondHash = szSigValue.indexOf("h(", szSigValue.indexOf(','));
        }

        if (indexOfFirstClose > 1 &&
                        szSigValue.lastIndexOf('{') ==
                        indexOfFirstClose + 1 &&
                        szSigValue.lastIndexOf('}') ==
                        szSigValue.length() - 1 &&
                        szAlgorithm.equalsIgnoreCase("Signature")) {

            if ( !szSigValue.substring(1, indexOfFirstClose).trim().equals(szRefSeq) ) {
                JOptionPane.showMessageDialog(null,
                                  "Signature: Inconsistency in SignatureValue", "Abort",
                                  JOptionPane.ERROR_MESSAGE);
                                  phData.phiAborted = true;
                                  return("");
            }

           //Return the key used to sign
           return(szSigValue.substring(szSigValue.lastIndexOf('{') + 1, szSigValue.length() - 1).trim());
        //if has a hmac structure then it looks as follows
        // h(k,h(text))
        } else if (nSecondHash > 0 &&
                   szSigValue.endsWith("))") &&
                   szSigValue.indexOf("))") > szSigValue.lastIndexOf(",") + 1  ){

            if ( !(szSigValue.substring(nSecondHash + 2, szSigValue.indexOf(',', nSecondHash)).trim().equals(szHmacKey) &&
                   szSigValue.substring(szSigValue.indexOf(',', nSecondHash) + 1, szSigValue.length() -2).trim().equals(szRefSeq)) ){

                    JOptionPane.showMessageDialog(null,
                                  "Signature: Inconsistency in SignatureValue", "Abort",
                                  JOptionPane.ERROR_MESSAGE);
                                  phData.phiAborted = true;
                                  return("");
              }
            //The key used in the hmac
            return(szHmacKey);
        }else {
            JOptionPane.showMessageDialog(null,
                                "Signature: SignatureValue contains invalid text", "Abort",
                                JOptionPane.ERROR_MESSAGE);
            phData.phiAborted = true;
            return("");
        }

    }

    //The signatureMethod element is a required sub elemet if the SignedInfo element
    //The Algorithm attribute is a required attribute of the SignatureMethod element
    //
    // Returns: yes if symetric key algorithm
    // Returns: mac if MAC algorithm
    private static String evalSignatureMethod(phiData phData,
                                              org.w3c.dom.Node evalNode,
                                              org.w3c.dom.Node SignedInfoNode){

        org.w3c.dom.Node SignatureMethodNode=null, indexNode, attrNode;
        org.w3c.dom.NodeList list;
        String szAlgorithmURI, szAlgorithmName;
        String[] options = {"Signature", "HMAC"};
        psiData psiAlgorithm;
        int nPosition;

        list = SignedInfoNode.getChildNodes();

        // Loop through the list.
        for (int i = 0; i < list.getLength(); i++) {
            indexNode = list.item(i);
            if (indexNode.getNodeType() == indexNode.ELEMENT_NODE)
                if (indexNode.getLocalName().equals("SignatureMethod"))
                    SignatureMethodNode = indexNode;

        }

        if ( SignatureMethodNode == null ) {
            JOptionPane.showMessageDialog(null,
                                "Signature: SignedInfo does not contain SignatureMethod", "Abort",
                                JOptionPane.ERROR_MESSAGE);
            phData.phiAborted = true;

            return ("");
        }

        attrNode = SignatureMethodNode.getAttributes().getNamedItemNS(phData.xmlSigURI,"Algorithm");

        if (attrNode == null)
            attrNode = SignatureMethodNode.getAttributes().getNamedItem("Algorithm");

        szAlgorithmURI = attrNode.getNodeValue();

        nPosition = szAlgorithmURI.lastIndexOf("xmldsig#") + 8;

        szAlgorithmName = szAlgorithmURI.substring(nPosition);

        //MAC
        if (szAlgorithmName.startsWith("hmac") ){
            return("hmac");
        }
        //Signature
        else if (szAlgorithmName.startsWith("dsa") || szAlgorithmName.startsWith("rsa") ){
            return("Signature");
        }

        //Algorithm was not recognized ask the user
        psiAlgorithm = phiClass.retPsiData(
            phData,
            evalNode,
            "Encrypting",
            "The algorithm used to for signing cannot be not reconized. Is it a Signture alogirhtm or MAC(Signature/MAC)",
            false,
            options);

        //Check if an answer supplied and if not return
        if (psiAlgorithm.getPsiDataValue().equals(""))
            return ("");
        else
            return(psiAlgorithm.getPsiDataValue());

    }


    //This Signature element does not contain a KeyInfo element.
    //We ask the user for the key
    public static String checkKeyInfo(phiData phData,
                                      org.w3c.dom.Node evalNode,
                                      String szAlgorithm) {
        String szEncrypting="";
        psiData psiEncryptedKey;


        if (szAlgorithm.equalsIgnoreCase("Signature"))
            psiEncryptedKey = phiClass.retPsiData(phData, evalNode, "Encrypting", "The signing key in the mark Signature element seems to be agreed applicatively. Please specify the public ey owner", true, null);
        else //if it is MAC
            psiEncryptedKey = phiClass.retPsiData(phData, evalNode, "Encrypting", "The MAC-key in the mark Signature element seems to be agreed applicatively. Please specify the key", false, null);

        szEncrypting = psiEncryptedKey.getPsiDataValue();

        //Check if a key supplied and if not return
        if (szEncrypting.equals(""))
            return ("");

        if (szAlgorithm.equalsIgnoreCase("Signature"))
            szEncrypting = "SK(" + szEncrypting + ")";

        return(szEncrypting);
    }

}
