package phi;

import org.w3c.dom.Document;
import java.util.Set;
import java.util.HashSet;
import java.util.Iterator;
import java.awt.Frame;
import javax.swing.JOptionPane;
import javax.xml.parsers.DocumentBuilderFactory;
import java.io.File;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class phiData {

    boolean bValidating;

    String utilitySchemaURI;
    String utilitySchemaFILE;

    String wssSchemaURI;
    String wssSchemaFILE;

    String soapSchemaURI;
    String soapSchemaFILE;

    String xmlEncURI;
    String xmlEncFILE;

    String xmlSigURI;
    String xmlSigFILE;

    DocumentBuilderFactory factory;

    //parser reposrt varialbes
    boolean XMLParserNonFatalError = false;
    boolean XMLParserFatalError = false;
    String szParserLog="";

    private boolean bTrace = false;
    Document document;
    String szSOAPFileName = null;
    String szSOAPFileData = null;
    File fhSOAP = null;
    String psiResult = null;
    boolean phiAborted = false;
    boolean bAbstracted;
    private Set psiDataSet;
    private Set contextSet;
    private Set CarriedNamesSet;
    int nLocation;
    Frame parent;


    public phiData() {
      contextSet = new HashSet();
      psiDataSet = new HashSet();
    }

    public void finalize(){
        contextSet.clear();
        psiDataSet.clear();
    }


    public void phiTrace(String szOutput){
    if (bTrace)
      System.out.println(szOutput);
   }

   public void setSOAPFileName(String szFileName){
       szSOAPFileName = szFileName;
   }

   public void setSOAPFileHandler(File newfhSOAP){
       fhSOAP = newfhSOAP;
   }


   public void setFrameparent(Frame newParent){
       parent = newParent;
   }


   public void setSOAPFileData(String szFileData){
       szSOAPFileData = szFileData;
   }

   public String getSOAPFileData(){
       return(szSOAPFileData);
   }


   public boolean isXMLParserFatalError(){
       return XMLParserFatalError;
   }

   public boolean isXMLParserNonFatalError(){
       return XMLParserNonFatalError;
   }


   public void setAbstracted(boolean abstracted){
       bAbstracted = abstracted;
   }

   public boolean isbAbstracted(){
       return(bAbstracted);
   }

   public Document getDocument() {
       return(document);
   }

   public String getParserLog() {
       return(szParserLog);
   }

   public boolean isPhiAborted(){
       return(phiAborted);
   }

   public Set getPsiDataSet(){
       return(psiDataSet);
   }

   /*************************************
   //Parser initialization
  ***************************************/
   public void setParsingOptions(boolean Validating){
       bValidating = Validating;
   }

   public void setWssSchema(String szURI, String szFile){
       wssSchemaURI = szURI;
       wssSchemaFILE = szFile;
   }

   public void setSoapSchema(String szURI, String szFile){
       soapSchemaURI = szURI;
       soapSchemaFILE = szFile;
   }

   public void setUtilitySchema(String szURI, String szFile){
       utilitySchemaURI = szURI;
       utilitySchemaFILE = szFile;
   }

   public void setXmlEncSchema(String szURI, String szFile){
          xmlEncURI = szURI;
          xmlEncFILE = szFile;
   }

   public void setXmlSigSchema(String szURI, String szFile){
           xmlSigURI = szURI;
           xmlSigFILE = szFile;
    }

  public void setFactory(DocumentBuilderFactory newFactory){
          factory = newFactory;
  }

  public DocumentBuilderFactory getFactory(){
      return(factory);
  }


   /*************************************
   //context list functions
  ***************************************/
   public void phiClearContext() {
      contextSet.clear();
   }

   public void phiSaveContext(context newContext){

    if (newContext.getContextValue().equals("")){
      System.err.println("null context name is illegal");
      System.exit(1);
    }

    if (!contextSet.add(newContext)){
      System.err.println("Duplicate Context");
      System.exit(1);
    }
  }

  public context phiRetContext(String contextName){
    Iterator iter;
    context tempContext;
    for (iter = contextSet.iterator(); iter.hasNext(); ){
      tempContext = (context) iter.next();
      if (tempContext.getContextName().equals(contextName))
        return(tempContext);
    }
    tempContext = new context(true);
    return(tempContext);
  }


   /*************************************
   //PsiData list functions
  ***************************************/
  public void phiSavePsiData(psiData newPsiData){

    if (!psiDataSet.add(newPsiData)){
        System.err.println("Duplicate psi data");
        System.exit(1);

    }
  }

  public psiData phiRetPsiData(org.w3c.dom.Node psiDataNode, String szIdentifier){
    Iterator iter;
    psiData tempPsiData;

    for (iter = psiDataSet.iterator(); iter.hasNext(); ){
      tempPsiData = (psiData) iter.next();
      if (tempPsiData.getPsiDataNode() != null &&
          tempPsiData.getPsiDataNode().equals(psiDataNode) &&
          tempPsiData.getPsiDataIdentifer().matches(szIdentifier) )
        return(tempPsiData);
    }
    tempPsiData = new psiData(true);
    return(tempPsiData);
  }

  public psiData phiRetPsiDataByValue(String szIdentifier,
                                      String szValue){
    Iterator iter;
    psiData tempPsiData;

    for (iter = psiDataSet.iterator(); iter.hasNext(); ){
      tempPsiData = (psiData) iter.next();
      if (tempPsiData.getPsiDataIdentifer().matches(szIdentifier) &&
          tempPsiData.getPsiDataValue().matches(szValue) )
        return(tempPsiData);
    }
    tempPsiData = new psiData(true);
    return(tempPsiData);
  }


  //get a Node of a key and returns whther it is a symmetric key
  public boolean phiIsSymmetric(String szValue){
    Iterator iter;
    psiData tempPsiData;

    if ( szValue.startsWith("PK(") || szValue.startsWith("SK("))
        szValue = szValue.substring(3, szValue.lastIndexOf(')'));

    for (iter = psiDataSet.iterator(); iter.hasNext(); ){
      tempPsiData = (psiData) iter.next();
      if ( (tempPsiData.getPsiDataIdentifer().matches("Key") ||
            tempPsiData.getPsiDataIdentifer().matches("EncryptedKey")) &&
          tempPsiData.getPsiDataValue().matches(szValue) )
        return(tempPsiData.isPsiDataSymetricKey());
    }
       System.err.println("phiData: phiIsSymmetric was called for key that does not exists");
       return(false);
  }



  /*************************************
  //carried key names list functions
 ***************************************/

  public void setCarriedNamesSet(Set CarriedNames){
      CarriedNamesSet = CarriedNames;
  }

  public void phiSaveKeyName(String szKeyName, String szKey, boolean bSymmetric){
    Iterator iter;
    CarriedKeyNames tempCarriedKeyNames;
    CarriedKeyNames newCarriedKeyNames = new CarriedKeyNames();

    for (iter = CarriedNamesSet.iterator(); iter.hasNext(); ){
      tempCarriedKeyNames = (CarriedKeyNames) iter.next();
      if ( tempCarriedKeyNames.getCarriedNameIdentifer().equals(szKeyName) ){
          if ( tempCarriedKeyNames.getCarriedNameValue().equals(szKey) )
              return;
          else{
             JOptionPane.showMessageDialog(null,"Two Key are associated with the same name", "Alert", JOptionPane.ERROR_MESSAGE);
          }
      }
    }

    newCarriedKeyNames.setCarriedNameEmpty(false);
    newCarriedKeyNames.setCarriedNameIdentifier(szKeyName);
    newCarriedKeyNames.setCarriedNameValue(szKey);
    newCarriedKeyNames.setCarriedNameSymmetric(bSymmetric);

    CarriedNamesSet.add(newCarriedKeyNames);
  }


  public CarriedKeyNames phiRetKeyName(String szKeyName){
    Iterator iter;
    CarriedKeyNames tempCarriedKeyNames;

    for (iter = CarriedNamesSet.iterator(); iter.hasNext(); ){
      tempCarriedKeyNames = (CarriedKeyNames) iter.next();
      if ( tempCarriedKeyNames.getCarriedNameIdentifer().equals(szKeyName) )
        return(tempCarriedKeyNames);
    }

    return(null);
  }

}
