package sud;

import org.w3c.dom.Document;
import java.io.File;
import phi.phiData;
import phi.parserClass;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class SUDClass_EnvInit {

    static final String szConfigurationFileName = "Init.cfg";

    //Managing status bar variable
    private String szLog="";

    //Applicable variables
    SUDData localData;

    public SUDClass_EnvInit(SUDData mdData) {
        localData = mdData;
    }

    /**
     * Returns Initialization Log
     */
    public String getLog() {
        return szLog;
    }


    //Main initializing function, called by SUDFrame
    public void InitEnvir(SUDData mdData) {

       Document document;
       phiData phData = new phiData();
       File file;

       setDefaults(mdData);

       phData.setParsingOptions(false);
       parserClass.setParserConfiguration(phData);
       file = openFile(szConfigurationFileName);
       if ( file == null) {
           szLog = szLog.concat("Configration file was not found\n\n");
       } else {
           phData.setSOAPFileHandler(file);
           parserClass.loadXML(phData);
           if (phData.isXMLParserFatalError() ) {
               szLog = szLog.concat("Error in parsing Configuration file\n\n");
               szLog = szLog.concat(phData.getParserLog());
           } else {
               document = phData.getDocument();

               InitParticipantsTypes(mdData, document);

               initParser(mdData, document);


           }
       }

   }


   /*
      Get all the participants types defined by the user
    */
   public void InitParticipantsTypes(SUDData mdData, Document document) {

       org.w3c.dom.Node indexNode, ParticipantTypesNode=null;
       org.w3c.dom.NodeList list;
       int i, nTypeNumber = 0;
       String[] DefaultTypes = { "Agent", "Server" };
       String[] Types;

       list = document.getDocumentElement().getChildNodes();


       // Loop through the list.
       for (i = 0; i < list.getLength(); i++) {
           indexNode = list.item(i);
           if (indexNode.getNodeType() == indexNode.ELEMENT_NODE)
               if (indexNode.getLocalName().equals("ParticipantTypes") ) {
                   if ( ParticipantTypesNode != null ) {
                       szLog = szLog.concat("More than one ParticipantTypes element was found in configuration file\n\n");
                       return;
                   }
                   else
                       ParticipantTypesNode = indexNode;
               }
       }

       if ( ParticipantTypesNode == null ) {
           szLog = szLog.concat("no ParticipantTypes were set\n Default is used\n\n");
           mdData.Types = DefaultTypes;
       }
       else {
           szLog = szLog.concat("Defing ParticipantTypes\n");
           list = ParticipantTypesNode.getChildNodes();
           for (i = 0; i < list.getLength(); i++) {
               indexNode = list.item(i);
               if (indexNode.getNodeType() == indexNode.ELEMENT_NODE)
                   if (indexNode.getLocalName().equals("Type") )
                       nTypeNumber++;
           }

           Types = new String[nTypeNumber];
           int nArrayLocation = 0;
           for (i = 0; i < list.getLength(); i++) {
               indexNode = list.item(i);
               if (indexNode.getNodeType() == indexNode.ELEMENT_NODE)
                   if (indexNode.getLocalName().equals("Type") ) {
                       Types[nArrayLocation] = indexNode.getFirstChild().getNodeValue().trim();
                       szLog = szLog.concat("   Type " + indexNode.getFirstChild().getNodeValue() + " was defined\n");
                       nArrayLocation++;
                   }
           }
           mdData.Types = Types;

       }

       szLog = szLog.concat("\n");


   }

   /*
      Initializing parser attributes
    */
   private void initParser(SUDData mdData, Document document){

       org.w3c.dom.Node indexNode, ParserAttrNode=null;
       org.w3c.dom.NodeList list;
       int i;
       boolean bValidatingExtracted = false, bSchemasExtracted = false, bSchemasURIExtracted = false;

       list = document.getDocumentElement().getChildNodes();

       // Loop through the list.
       for (i = 0; i < list.getLength(); i++) {
           indexNode = list.item(i);
           if (indexNode.getNodeType() == indexNode.ELEMENT_NODE)
               if (indexNode.getLocalName().equals("ParserAttributes") ) {
                   if ( ParserAttrNode != null ) {
                       szLog = szLog.concat("More than one ParserAttributes element was found in configuration file\n\n");
                       return;
                   }
                   else
                       ParserAttrNode = indexNode;
               }
       }

       if  ( ParserAttrNode != null )
           list = ParserAttrNode.getChildNodes();
       else {
           return;
       }

       // Loop through the list.
       for (i = 0; i < list.getLength(); i++) {
           indexNode = list.item(i);
           if (indexNode.getNodeType() == indexNode.ELEMENT_NODE)
               if (indexNode.getLocalName().equals("Validating") ) {
                   if ( bValidatingExtracted ) {
                       szLog = szLog.concat("More than one Validating element was found in configuration file\n\n");
                       return;
                   }
                   else {
                       bValidatingExtracted = true;
                       setValidating(mdData, indexNode);
                   }
               } else if (indexNode.getLocalName().equals("Schemas") ) {
                   if ( bSchemasExtracted ) {
                       szLog = szLog.concat("More than one Schemas element was found in configuration file\n\n");
                       return;
                   } else {
                       bSchemasExtracted = true;
                       setShemas(mdData, indexNode);
                   }
               } else if (indexNode.getLocalName().equals("SchemasURI") ) {
                   if ( bSchemasURIExtracted ) {
                       szLog = szLog.concat("More than one SchemasURI element was found in configuration file\n\n");
                       return;
                   } else if ( mdData.bValidating ){
                       szLog = szLog.concat("Validating must be set to False if schemas are not loaded\n\n");
                       return;
                   } else {
                       bSchemasURIExtracted = true;
                       setShemasURI(mdData, indexNode);
                   }
               } else
                   szLog = szLog.concat(indexNode.getLocalName()  + "  is invalid ParserAttributes subelement\n");
       }


   }


   /*
       Set schemas
    */
   private void setShemas(SUDData mdData, org.w3c.dom.Node schemaNode){
       org.w3c.dom.Node indexNode;
       org.w3c.dom.NodeList list;
       String tempBool;

       list = schemaNode.getChildNodes();

       // Loop through the list.
       for (int i = 0; i < list.getLength(); i++) {
           indexNode = list.item(i);
           if (indexNode.getNodeType() == indexNode.ELEMENT_NODE)
               if (indexNode.getLocalName().equals("soapSchema") ) {
                   if ( !mdData.soapSchemaFILE.equals("") ) {
                       szLog = szLog.concat("More than one soapSchema element was found in configuration file\n\n");
                   } else {
                       mdData.soapSchemaFILE = indexNode.getFirstChild().getNodeValue().trim();
                       tempBool = indexNode.getAttributes().getNamedItem("Validate").getNodeValue();
                       if ( tempBool != null && (tempBool.equalsIgnoreCase("True") || tempBool.equalsIgnoreCase("False")) ) {
                           if ( tempBool.equalsIgnoreCase("True") )
                               mdData.soapSchemaValidate = true;
                           else
                               mdData.soapSchemaValidate = false;
                       } else
                           szLog = szLog.concat("Invalid Validating value for soapSchema, value was set to False\n\n");
                       mdData.soapSchemaURI = getSchemaName(mdData.soapSchemaFILE);
                       if (mdData.soapSchemaURI.equals(""))
                           mdData.soapSchemaFILE = "";
                   }
               } else if (indexNode.getLocalName().equals("utilitySchema") ) {
                   if ( !mdData.utilitySchemaFILE.equals("") ) {
                       szLog = szLog.concat("More than one utilitySchema element was found in configuration file\n\n");
                   } else {
                       mdData.utilitySchemaFILE = indexNode.getFirstChild().getNodeValue().trim();
                       tempBool = indexNode.getAttributes().getNamedItem("Validate").getNodeValue();
                       if ( tempBool != null && (tempBool.equalsIgnoreCase("True") || tempBool.equalsIgnoreCase("False")) ) {
                           if ( tempBool.equalsIgnoreCase("True") )
                               mdData.utilitySchemaValidate = true;
                           else
                               mdData.utilitySchemaValidate = false;
                       } else
                           szLog = szLog.concat("Invalid Validating value for utilitySchema, value was set to False\n\n");

                       mdData.utilitySchemaURI = getSchemaName(mdData.utilitySchemaFILE);
                       if (mdData.utilitySchemaURI.equals(""))
                           mdData.utilitySchemaFILE = "";
                   }
               } else if (indexNode.getLocalName().equals("wssSchema") ) {
                   if ( !mdData.wssSchemaFILE.equals("") ) {
                       szLog = szLog.concat("More than one wssSchema element was found in configuration file\n\n");
                   } else {
                       mdData.wssSchemaFILE = indexNode.getFirstChild().getNodeValue().trim();
                       tempBool = indexNode.getAttributes().getNamedItem("Validate").getNodeValue();
                       if ( tempBool != null && (tempBool.equalsIgnoreCase("True") || tempBool.equalsIgnoreCase("False")) ) {
                           if ( tempBool.equalsIgnoreCase("True") )
                               mdData.wssSchemaValidate = true;
                           else
                               mdData.wssSchemaValidate = false;
                       } else
                           szLog = szLog.concat("Invalid Validating value for wssSchema, value was set to False\n\n");

                       mdData.wssSchemaURI = getSchemaName(mdData.wssSchemaFILE);
                       if (mdData.wssSchemaURI.equals(""))
                           mdData.wssSchemaFILE = "";
                   }
               } else if (indexNode.getLocalName().equals("xmlEnc") ) {
                   if ( !mdData.xmlEncFILE.equals("") ) {
                       szLog = szLog.concat("More than one xmlEnc element was found in configuration file\n\n");
                   } else {
                       mdData.xmlEncFILE = indexNode.getFirstChild().getNodeValue().trim();
                       tempBool = indexNode.getAttributes().getNamedItem("Validate").getNodeValue();
                       if ( tempBool != null && (tempBool.equalsIgnoreCase("True") || tempBool.equalsIgnoreCase("False")) ) {
                           if ( tempBool.equalsIgnoreCase("True") )
                               mdData.xmlEncValidate = true;
                           else
                               mdData.xmlEncValidate = false;
                       } else
                           szLog = szLog.concat("Invalid Validating value for xmlEnc, value was set to False\n\n");

                       mdData.xmlEncURI = getSchemaName(mdData.xmlEncFILE);
                       if (mdData.xmlEncURI.equals(""))
                           mdData.xmlEncFILE = "";
                   }
               } else if (indexNode.getLocalName().equals("xmlSig") ) {
                   if ( !mdData.xmlSigFILE.equals("") ) {
                       szLog = szLog.concat("More than one xmlSig element was found in configuration file\n\n");
                   } else {
                       mdData.xmlSigFILE = indexNode.getFirstChild().getNodeValue().trim();
                       tempBool = indexNode.getAttributes().getNamedItem("Validate").getNodeValue();
                       if ( tempBool != null && (tempBool.equalsIgnoreCase("True") || tempBool.equalsIgnoreCase("False")) ) {
                           if ( tempBool.equalsIgnoreCase("True") )
                               mdData.xmlSigValidate = true;
                           else
                               mdData.xmlSigValidate = false;
                       } else
                           szLog = szLog.concat("Invalid Validating value for xmlSig, value was set to False\n\n");

                       mdData.xmlSigURI = getSchemaName(mdData.xmlSigFILE);
                       if (mdData.xmlSigURI.equals(""))
                           mdData.xmlSigFILE = "";
                   }
               } else {
                   szLog = szLog.concat(indexNode.getLocalName() + " is not a valid child of Schemas\n\n");
               }
       }

       szLog = szLog.concat("\n");

   }

   /*
      Set schemas URI
    */
   private void setShemasURI(SUDData mdData, org.w3c.dom.Node schemaNode){
       org.w3c.dom.Node indexNode;
       org.w3c.dom.NodeList list;

       list = schemaNode.getChildNodes();

       // Loop through the list.
       for (int i = 0; i < list.getLength(); i++) {
           indexNode = list.item(i);
           if (indexNode.getNodeType() == indexNode.ELEMENT_NODE)
               if (indexNode.getLocalName().equals("soapSchema") ) {
                   if ( !mdData.soapSchemaURI.equals("") ) {
                       szLog = szLog.concat("URI is alreay loaded for soapSchema\n\n");
                   } else
                       mdData.soapSchemaURI = indexNode.getFirstChild().getNodeValue().trim();
               } else if (indexNode.getLocalName().equals("utilitySchema") ) {
                   if ( !mdData.utilitySchemaURI.equals("") ) {
                       szLog = szLog.concat("URI is alreay loaded for utilitySchema\n\n");
                   } else
                       mdData.utilitySchemaURI = indexNode.getFirstChild().getNodeValue().trim();
               } else if (indexNode.getLocalName().equals("wssSchema") ) {
                   if ( !mdData.wssSchemaURI.equals("") ) {
                       szLog = szLog.concat("URI is alreay loaded for wssSchema\n\n");
                   } else
                       mdData.wssSchemaURI = indexNode.getFirstChild().getNodeValue().trim();
               } else if (indexNode.getLocalName().equals("xmlEnc") ) {
                   if ( !mdData.xmlEncURI.equals("") ) {
                       szLog = szLog.concat("URI is alreay loaded for xmlEnc\n\n");
                   } else
                       mdData.xmlEncURI = indexNode.getFirstChild().getNodeValue().trim();
               } else if (indexNode.getLocalName().equals("xmlSig") ) {
                   if ( !mdData.xmlSigURI.equals("") ) {
                       szLog = szLog.concat("URI is alreay loaded for xmlSig\n\n");
                   } else
                       mdData.xmlSigURI = indexNode.getFirstChild().getNodeValue().trim();
               } else {
                   szLog = szLog.concat(indexNode.getLocalName() + " is not a valid child of SchemasURI\n\n");
               }
       }

       szLog = szLog.concat("\n");

   }


   /*
      This Method gets a schema file name parse it and retrive
      the schema file name.
    */
   public String getSchemaName(String szSchmaFile) {

       phiData phData = new phiData();
       org.w3c.dom.Node targetNamespaceNode;
       File file;


       phData.setParsingOptions(false);
       parserClass.setParserConfiguration(phData);
       file = openFile(szSchmaFile);
       if (file == null) {
           szLog = szLog.concat(szSchmaFile + " does not exist\n");
       } else {
           phData.setSOAPFileHandler(file);
           parserClass.loadXML(phData);
           if ( phData.isXMLParserFatalError() ) {
               szLog = szLog.concat("Error in parsing " + szSchmaFile + " file\n");
               szLog = szLog.concat(phData.getParserLog());
           } else {
               targetNamespaceNode = phData.getDocument().getDocumentElement().getAttributes().getNamedItem("targetNamespace");
               if (targetNamespaceNode != null) {
                   szLog = szLog.concat(targetNamespaceNode.getNodeValue().trim() + " is set\n");
                   return (targetNamespaceNode.getNodeValue().trim());
               } else{
                   szLog = szLog.concat(szSchmaFile + " does not seem to be a valid schema\n");
               }
           }
       }
       return("");
   }
   /*
      Set validating option
    */
   private void setValidating(SUDData mdData, org.w3c.dom.Node validatingNode){

       String szValidatingValue = validatingNode.getFirstChild().getNodeValue().trim();

       if ( szValidatingValue.equalsIgnoreCase("True") ) {
           mdData.bValidating = true;
           szLog = szLog.concat("Validating is set to True\n\n");
       }
       else if ( szValidatingValue.equalsIgnoreCase("False") ) {
           mdData.bValidating = false;
           szLog = szLog.concat("Validating is set to False\n\n");
       }
       else
           szLog = szLog.concat("invalid Validating value, defualt is used\n\n");
   }

   /*
      Opening a file method returns file handler
    */
   private static File openFile(String szFileName){

       File file;

       file = new File(szFileName);

       if ( !file.exists() )
           file = null;

       return(file);
   }


   private void setDefaults(SUDData mdData) {

       String[] DefaultTypes = { "Agent", "Server" };

       mdData.Types = DefaultTypes;

       mdData.bValidating = false;

       mdData.soapSchemaURI = "http://www.w3.org/2001/12/soap-envelope";
       mdData.soapSchemaFILE = "";
       mdData.soapSchemaValidate = false;

       mdData.utilitySchemaURI = "http://schemas.xmlsoap.org/ws/2003/06/utility";
       mdData.utilitySchemaFILE = "";
       mdData.utilitySchemaValidate = false;

       mdData.wssSchemaURI = "http://schemas.xmlsoap.org/ws/2003/06/secext";
       mdData.wssSchemaFILE = "";
       mdData.wssSchemaValidate = false;

       mdData.xmlSigURI = "";
       mdData.xmlSigFILE = "";
       mdData.xmlSigValidate = false;

       mdData.xmlEncURI = "http://www.w3.org/2001/04/xmlenc#";
       mdData.xmlEncFILE = "";
       mdData.xmlEncValidate = false;

   }

}
